{{
' JvmMonDebug.spin - Jan 24, 2008
  This .spin module is a convenience wrapper for VGA_Text with Jvm debug features.
  More methods to manage JVM debug information will be added to this file.

  Output Example
  --------------------------------
    pc $0000  sp $0000   bp $0000
    op $0000 lhs $0000  rhs $0000
  heap $0000 use $0000 free $0000
  Frame$0000
  OpCode <opcode name><operands>
  
  -- debug section --

  -- error section --

  --------------------------------
}}

{{

<jazzed>
}}

CON  
  debug = 1
  MAXX = 32
  MAXY = 15
  START_Y = 1
  REG_Y = START_Y
  PC_X = 6
  SP_X = 20
  BP_X = 6
  EX_X = 20
  JOP_Y= REG_Y+2
  JEM_X = 6
  OPC_X = 20
  LHS_X = 6
  RHS_X = 20
  HEAP_Y = JOP_Y+2
  HP_X = 6
  HU_X = PC_X
  HF_X = SP_X
  FRM_Y = HEAP_Y+1
  FRM_X = 6
  OPS_Y = FRM_Y+1
  OPS_X = 0
  DEB_Y = OPS_Y+2
  DEB_X = 0
  
  ERR_X = 0
  ERR_Y = 13 ' best number for an error don't you think :)
  
OBJ
' mon: "VGA_Text"  ' This module will use VGA_Text and PASM code will use TV_text.
' mon: "TV_Text" ... untested but some chance of working if necessary.
  mon: "Jazzed_SIO_Text"
  
PUB init
{{
/**
 * module init
 */
}}
  'mon.start(16)
  mon.start(31, 30, 0, 9600)
  repeat while(mon.key == 0)
  CLS
   
PUB showDebugDisplay
    CLS
    home
    setcolor(0)
    newline(START_Y)
    str(string("  PC $00000000  SP $00000000",$D))
    str(string("  BP $00000000 Ext $00000000",$D))
    str(string(" JEM $00   Operand $00000000",$D))
    str(string(" LHS $00000000 RHS $00000000",$D))
    str(string("  Hp $00000000 Use $00000000",$D))
    str(string(" Frm $0000 ",$D))


PUB getDebug : rc
{{
/**
 * getDebug module debug state
 * @returns non-zero if debug is enabled
 */
}}
  rc := debug
  return debug

{
PUB isKey :rc
{{
/**
 * see if we have a keypress
 * @returns non-zero if key is available
 */
}}
  rc := mon.key
}

PUB getch :rc
{{
/**
 * @returns available character
 */
}}
  rc := mon.getch
        
PUB getMaxX : rc
{{
/**
 * get max X columns
 * @returns maximum number of X columns in screen
 */
}}
  rc := MAXX
  
PUB getMaxY : rc
{{
/**
 * get max Y rows
 * @returns maximum number of Y rows in screen
 */
}}
  rc := MAXY
  
' mon.out(val) screen printing
' Output a character
'
'     $00 = clear screen
'     $01 = home
'     $08 = backspace
'     $09 = tab (8 spaces per)
'     $0A = set X position (X follows)
'     $0B = set Y position (Y follows)
'     $0C = set color (color follows)
'     $0D = return
'  others = printable characters

PUB cls
{{
/**
 * clear screen
 */
}}
  mon.out(0)
  
PUB home
{{
/**
 * send screen cursor home
 */
}}
  mon.out(1)
{  
PUB bksp(num)
{{
/**
 * send cursor back num spaces
 * @param num is number of backspaces
 */
}}
  repeat num
    mon.out(8)
   
PUB tab(num)
{{
/**
 * insert num tabs
 * @param num is number of tabs
 */
}}
  repeat num
    mon.out(9)
}
PUB setxy(x,y)
{{
/**
 * set cursor to new y position
 * @param x is x position
 * @param y is y position
 */
}}
  mon.out($A)
  mon.out(x)
  mon.out($B)
  mon.out(y)
   
PUB setcolor(val)
{{
/**
 * set new color
 * @param val is color based on ... ?
 */
}}
  mon.out($C)
  mon.out(val)
   
PUB newline(num)
{{
/**
 * insert num new lines
 * @param num is number of new lines
 */
}}
  repeat num
    mon.out($D)
   
PUB pause(ms) | mval
{{
/**
 * pause a number of milliseconds
 * @param ms is number of milliseconds
 */
}}
  mval := clkfreq / 1_000
  mval := mval * ms
  waitcnt(cnt+mval)

PUB out(val)
{{
/**
 * send val to monitor
 * @param val display value
 */
}}
  mon.out(val)
 
PUB dec(val)
{{             
/**
 * send val to monitor as decimal number
 * @param val number to display
 */
}}
  mon.dec(val)
 
PUB hex(val,num)
{{
/**
 * send val to monitor as hex number
 * @param val number to display
 * @param num number of digits to display
 */
}}
  mon.hex(val,num)

PUB str(val)
{{
/**
 * send string to monitor
 * @param val string to display
 */
}}
  mon.str(val)

{
PUB dumpAll(addr,len) | ndx
{{
/**
 * dump bytes in 8 column table with prepended address
 * @param addr is base address for dump
 * @param len is number of bytes to dump
 */
}}
  ndx := 0
  'str(string("Dump"))
  if getDebug 'and ndx < $40
    repeat while(ndx < len)
      if ndx == 0
        home
      if ndx <> 0 and (ndx // 8) == 0
        newline(1)
        hex(ndx,4)
        str(string(": "))
      else
        str(string("."))
      hex(byte[addr+ndx++],2)
}
   
PUB dumpBytes(addr,len) | ndx
{{
/**
 * dump bytes in 8 column table
 * @param addr is base address for dump
 * @param len is number of bytes to dump
 */
}}
  ndx := 0
  'str(string("Dump"))
  repeat while(ndx < len)
    if ndx <> 0 and (ndx // 8) <> 0
      str(string("."))
    hex(byte[addr+ndx++],2)
    if ndx == 0 or (ndx // 8) == 0
      newline(1)
    
PUB showPC(v)
{{
/**
 * Display program counter
 * @param v is pc value to display
 */
}}
  setxy(PC_X,REG_Y)
  hex(v,8)
   
PUB showSP(v)
{{
/**
 * Display program counter
 * @param v is sp value to display
 */
}}
  setxy(SP_X,REG_Y)
  hex(v,8)
   
PUB showBP(v)
{{
/**
 * Display base pointer
 * @param v is bp value to display
 */
}}
  setxy(BP_X,REG_Y)
  hex(v,8)
 
PUB showOperator(v)
{{
/**
 * Display passed Opcode
 * @param v is bp value to display
 */
}}
  setxy(JEM_X,JOP_Y)
  hex(v,2)
  
PUB showOperand(v)
{{
/**
 * Display passed Opcode
 * @param v is bp value to display
 */
}}
  setxy(OPC_X,JOP_Y+1)
  hex(v,8)
 
PUB showLHS(v)
{{
/**
 * Display passed LHS
 * @param v is bp value to display
 */
}}
  setxy(LHS_X,JOP_Y+1)
  hex(v,8)
 
PUB showRHS(v)
{{
/**
 * Display passed RHS
 * @param v is bp value to display
 */
}}           
  setxy(RHS_X,JOP_Y+1)
  hex(v,8)
 
PUB showFrame(v)
{{
/**
 * Display Frame info
 * @param v is frame value to display
 */
}}
  setxy(FRM_X,FRM_Y)
  hex(v,4)
   
PUB showOps(s,code,addr,len)
{{
/**
 * Display Opcode/operand info
 * @param s is debug string to display
 * @param addr is address start data to display
 * @param len  is length of data to display
 */
}}
  setxy(OPS_X,OPS_Y)
  str(string("Opcd $"))
  hex(code,2)
  out($3a)
  str(s)
  str(string($D,"     "))
  dumpBytes(addr,len)
   
PUB showDebug(s,addr,len)
{{
/**
 * Display debug info
 * @param s is debug string to display
 * @param addr is address start data to display
 * @param len  is length of data to display
 */
}}
  newline(1)
  str(s)
  dumpBytes(addr,len)
 
PUB showError(s)
{{
/**
 * Display Error info
 * @param s is string value to display
 */
}}
  setxy(ERR_X,ERR_Y)
  mon.str(string("VM Error: "))
  mon.str(s)
 
PUB printHex(s,val,count)
{{
/**
 * Display debug info
 * @param s is debug string to display
 * @param val is data to display
 * @param count is number of digits to display
 */
}}
  newline(1)
  str(s)
  hex(val,count)
 
{{

</jazzed>
}}