{{
' JVM_jazzLib.spin
  This .spin module contains methods for JVM bytecode processing

  The doCode method is called with a JVM context and each method is dispatched from a case statement.
  If nothing was done, the switch returns -1. On error switch returns an enumerated positive integer
  that can be used as an index to an error message. A successful transaction returns 0. 
}}

{{

<jazzed>
}}

OBJ

  jem           : "Jazzed_JVM_JemDefs"         ' JEM Bytecode defines
  mon           : "Jazzed_JVM_MonDebug"

VAR
  long pc         'long 0
  long sp         'long 0
  long bp         'long 0
  long opc        'long 0
  long opr        'long 0
  long lhs        'long 0
  long rhs        'long 0
  long stack      'long 0
  long heap       'long 0

DAT

   e0         byte "No Error", 0
   e1         byte "Yada! ", 0
   e2         byte "Yada Yada! ", 0
   e3         byte "Yada Yada Yada! ", 0
   
   errors     long @e0, @e1, @e2
       
PUB main

PUB getError(num) : rc
  rc := @@errors[num]

PRI push(val)
' local push and pop
  word[ ++sp ] := val
  
PRI pop
  return word[ sp-- ]

PRI jpush(val)
  word[ ++stack ] := val
  
PRI jpop
  return word[ stack-- ]

    
PUB doCode(ipc, isp, ibp, iopc, iopr, ilhs, irhs, istack, iheap) : rc
  pc := ipc
  sp := @isp
  bp := @ibp
  opc:= iopc
  opr:= iopr
  lhs:= ilhs
  rhs:= irhs
  stack := istack
  heap  := iheap
  rc := 0

  mon.setxy(0,10)
  mon.str(string("OPCODE "))
  mon.hex(opc,2)
  
  case opc
  
      jem#Jem_ILOAD:            push(long[bp+(opr*4)])

      jem#Jem_IF_ICMPGT:        rhs := Pop
                                lhs := Pop
                                If lhs > rhs
                                  pc := pc + opr
                                
      jem#Jem_IADD:             rhs := Pop
                                lhs := Pop     
                                lhs := lhs + rhs
                                Push( lhs )
    other:
      rc := -1

  return rc
      
{{

</jazzed>
}}